package org.bitbucket.bradleysmithllc.etlunit;

public interface DiffGridRow
{
	/**
	 * For changed rows only.  For source added or target added
	 * disregard this method.
	 *
	 * @param col
	 */
	void setColumnName(String col);

	/**
	 * Sets the order key for this row
	 *
	 * @param key
	 */
	void setOrderKey(String key);

	/**
	 * Source value, or null if the target row is added
	 *
	 * @param value
	 */
	void setSourceValue(String value);

	/**
	 * Target value (always different), unless
	 * source row is unmatched.
	 *
	 * @param value
	 */
	void setTargetValue(String value);

	void done();
}