package org.bitbucket.bradleysmithllc.etlunit;

public class ETLTestCoordinator
{
	private final ClassBroadcaster broadcaster;
	private final StatusReporter statusReporter;

	public ETLTestCoordinator(ClassBroadcaster broadcaster, StatusReporter statusReporter)
	{
		this.broadcaster = broadcaster;
		this.statusReporter = statusReporter;
	}

	public void beginTesting()
	{
		// count the number of tests to run
		int testCount = broadcaster.broadcast(true);

		// broadcast to the listeners
		statusReporter.testsStarted(testCount);

		broadcaster.reset();

		try
		{
			// what to do here?
			broadcaster.broadcast(statusReporter);
		}
		finally
		{
			statusReporter.testsCompleted();
		}
	}
}